(function () {
    "use strict";

    angular.module('core').controller('pedidoAbastecimentoController', controller);
    controller.$inject = ['$scope', '$window', '$timeout', '$q', '$state', '$alert', 'pedidoAbastecimentoService', 'lookupService'];

    function controller($scope, $window, $timeout, $q, $state, $alert, pedidoAbastecimentoService, lookupService) {
        $scope.initializeLayout('Pedido de Abastecimento');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            displayWidth: $window.innerWidth,
            count: 0,
            filtro: {
                ativo: false,
                args: null
            }
        };
        angular.element($window).bind('resize', function () {
            $scope.$apply(function () {
                $scope.state.displayWidth = $window.innerWidth;
            });
        });
        $scope.isMobile = function () {
            return $scope.state.displayWidth <= 768;
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {
                    item: {}
                },
                consultar: function (action) {
                    debugger
                    if ($scope.popups.add.data && $scope.popups.add.data.item.Filial.Empresa.ID) {
                        if ($scope.popups.add.data.item.FilialOrigem != null && $scope.popups.add.data.item.Filial.Empresa.ID == $scope.popups.add.data.item.FilialOrigem.Empresa.ID) {
                            $scope.tools.toastr.error('A filial origem nao pode ser a mesma selecionada como a repor!');
                            return
                        }
                        $scope.$parent.dataTransfer = $scope.popups.add.data.item;
                        $state.go("state-pedido-abastecimento-consulta")
                    }
                    else {
                        $scope.tools.toastr.error('Selecione uma filial para iniciar uma consulta!');
                    }
                    
                   // $state.go("state-pedido-abastecimento-edit");
                },
                save: function (action) {
                    $scope.state.salvando = true;
                    pedidoAbastecimentoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $state.go("state-pedido-abastecimento-edit", { id: response.Data.ID });
                                    
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: {
                    save: 0,
                    saveAndNew: 1,
                    saveAndEdit: 2,
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    pedidoAbastecimentoService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 6,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            }
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                
                                $scope.popups.add.data.PlanoAbastecimento = null;
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            planoAbastecimento: {
                lookup: function (chaves) {
                    return $q.when(
                      
                        lookupService
                            .getAllPlanoAbastecimento({ chaves: chaves, filtro: { Filial: { Empresa: { ID: $scope.popups.add.data.item.Filial.Empresa.ID } } } })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            $scope.refresh();
        };

        $scope.voltar = function () {
            $state.go("state-home-operacao")

        }
        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            pedidoAbastecimentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            pedidoAbastecimentoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.carregandoMais = true;
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            pedidoAbastecimentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.state.carregandoMais = false;
                    },
                    function (_error) {
                        $scope.state.carregandoMais = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };
        $scope.delete = function (id) {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            pedidoAbastecimentoService
                .delete(id)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        }
                        $scope.getAll();
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: {
                    Ativo: null,
                    Codigo: null,
                    Marca: { Codigo: null, Nome: null },
                    Colecao: { Codigo: null, Nome: null },
                    Tipo: { Codigo: null, Nome: null },
                    Grupo: { Codigo: null, Nome: null },
                    Subgrupo: { Codigo: null, Nome: null },
                    Linha: { Codigo: null, Nome: null },
                    Grade: { Codigo: null, Nome: null },
                    Unidade: { Codigo: null, Nome: null },
                    Composicao: { Codigo: null, Nome: null },
                    Fabricacao: {
                        ReferenciaFabricante: null,
                        Fornecedor: { Empresa: { Nome: null } },
                    },
                    Genero: null,
                    CanalVenda: {
                        Loja: null,
                        Franquia: null,
                        LojaVirtual: null,
                        AFV: null,
                        B2B: null,
                    },
                },
                filtroDe: { CadastradoEm: null },
                filtroAte: { CadastradoEm: null },
                filtroEm: [],
                sortExpression: '',
                skip: 0,
                take: 20
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        $scope.toggleView = function () {
            $scope.view.index = $scope.view.index == 0 ? 1 : 0;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();